using System.Collections;
using System;
using UnityEngine;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
                       CategoryBuilder.Create("Hotline Playground", "",ModAPI.LoadSprite("screenshot.png"));
        
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Biker", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Biker, also known as Helmet or Hacker, is the deuteragonist of Hotline Miami and a side character in Hotline Miami 2: Wrong Number. He is a former 50 Blessings agent.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("bikerpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("biker.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Biker's Helmet",
        DescriptionOverride = "yoooo",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("bikerhelmpreview.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BikerHelmet.png", 12f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("BikerHelmet.png");
            Instance.FixColliders();
        }  
    }
);

 ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Russian Mobster", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Mobsters (known as Mafia in the Level Editor) are the most common enemy in Hotline Miami and are one of the two most common enemy factions in Hotline Miami 2: Wrong Number, the other being Gangs.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("rusmobpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("RussianMobster.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Jacket", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Jacket, also referred to in game files as Player or P, is the main protagonist and player character of Hotline Miami, and a side character in Hotline Miami 2: Wrong Number. He received this fan nickname because of his distinctive letterman jacket", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Screenshot_607.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("jacket.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Richard",
        DescriptionOverride = "Do you like to hurt other people?",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("rmpreview.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("richardmask.png", 12f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("richardmask.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Richter", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Richter Berg, also known as The Rat, is a side character and an antagonist in Hotline Miami and a playable character in Hotline Miami 2: Wrong Number. He appears as the secondary antagonist of Hotline Miami and returns in Hotline Miami 2: Wrong Number as the protagonist of Act 5: Intermission. He is also the penultimate playable character in the game.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("richpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Richter.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Richter's mask",
        DescriptionOverride = "omg furry mask oh lawd",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("richmpreview.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Richtermask.png", 11f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("Richtermask.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "The Son", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Son is a playable character in Hotline Miami 2: Wrong Number. He is the current leader of the Russian Mafia and took over after his father killed himself during his encounter with Jacket in Hotline Miami.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("sonpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Son.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");
            var head2 = Instance.transform.GetChild(5);
                        var hat2 = new GameObject("hat2");
                        hat2.transform.SetParent(head2);
                        var hatsprite2 = hat2.AddComponent<SpriteRenderer>();
                        hat2.transform.localPosition = new Vector3(-0.01f, 0.03f);
                        hat2.transform.localScale = new Vector3(0.090f, 0.08f);
                        hatsprite2.sprite = ModAPI.LoadSprite("sonhair.png");
                        hatsprite2.sortingLayerName = "Top";
            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
            person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Alex", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Alex Davis, also known as Swan #1, is a playable protaganist in Hotline Miami 2: Wrong Number. She is a member of The Fans who is part of an inseparable duo known as the Swans with her twin brother Ash Davis, making them the third playable Fans.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("alexpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Alex.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");
            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
            person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Ash", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Ash Davis, also known as Swan #2, is a playable protaganist in Hotline Miami 2: Wrong Number. He is a member of The Fans, and is part of an inseparable duo known as the Swans with his twin sister Alex Davis, making them the third playable Fans. ", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("ashpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Ash.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Alex's backpack",
        DescriptionOverride = "backpack",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("backpack.png", 10f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("alexbackpack.png", 10f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "MiddleBody";
            armor.armorTier = 0;
            armor.otherSprite = ("alexbackpack.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Alex's mask",
        DescriptionOverride = "Alex",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("swan.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Alexmask.png", 11f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("Alexmask.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Ash's mask",
        DescriptionOverride = "Ash",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("swan.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Ashmask.png", 11f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("Ashmask.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Alex's hair",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("alexhair.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("alexhair.png", 11f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("alexhair.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Mark", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Mark, also known as The Bear, is a playable character in Hotline Miami 2: Wrong Number. He is a member of The Fans that wears a grizzly bear mask, and is the last Fan the player unlocks, becoming available upon completion of Execution. This also makes him the third-to-last playable character in the game.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Screenshot_606.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Mark.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Mark's hair",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("MarkHair.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MarkHair.png", 12f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("MarkHair.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Mark's mask",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("mmpreview.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Markmask2.png", 12f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("Markmask.png");
            Instance.FixColliders();
        }  
    }
);

		  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Mark's vest (Top)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Bulletproof?",
                    CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("mbpv.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("markvestupper.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 30f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );

		  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Mark's vest (Bottom)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Bulletproof?",
                    CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("mbpv.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("markvestbottom.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 30f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
            
                    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Thug", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Thugs are a common special type of enemy not encountered regularly until later in the games. They use their fists to beat playable characters to death and will not use any weapon, with the exceptions of the Heavy and Inspector subtypes.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thugpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Thug.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

          var backpack = new GameObject("Insulator");
          backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
          backpack.transform.localPosition = new Vector3(-0.02f, 0.05f);
          backpack.transform.localScale = new Vector3(0.7f, 0.6f);
          var backpackSprite = backpack.AddComponent<SpriteRenderer>();
          backpackSprite.sprite = ModAPI.LoadSprite("tummy.png", 6f);
          backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Debris";
            var backpack2    = ModAPI.LoadTexture("tummy.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
            person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    });

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Colombian", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Colombians, also known as the Colombian Cartel, are an enemy faction that appear in Hotline Miami 2: Wrong Number. Level-wise, they first appear in Dead Ahead, where Detective Manny Pardo is shown recklessly infiltrating a Colombian-occupied ship alone and killing dozens of Colombian mobsters on-board.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("colombpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Colombian.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Gang", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gangs are a common enemy faction found in Hotline Miami 2: Wrong Number. They are one of the two most common enemy factions in the game, the other being Mobsters.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("hdlmpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Gang member.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Manny Pardo", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Manuel 'Manny' Pardo, also known as The Cop or The Detective, is a playable character in Hotline Miami 2: Wrong Number. Gameplay-wise, he is the first player character to not wear a mask while killing.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("mannypreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("MannyPardo.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

 ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "Mendoza", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Mendoza is a sub-machine gun that appears in Hotline Miami 2: Wrong Number. It is used by the Colombians, and can be used by Manny Pardo and The Son.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("mendozapreview.png", 22f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mendoza.png", 22f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Mendoza.wav"),
                ModAPI.LoadSound("Mendoza.wav"),
                ModAPI.LoadSound("Mendoza.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

		  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Tony's vest (Top)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Bulletproof?",
                    CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("bpvpreview.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("tonyvestupper.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 30f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
            
		  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Tony's vest (Bottom)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Bulletproof?",
                    CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("bpvpreview.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("tonyvestlower.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 30f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Tony's mask",
        DescriptionOverride = "Lethal punches",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("Screenshot_605.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("tonymask.png", 11f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("Markmask.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
        NameOverride = "Double barrel", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Double Barrel is a common firearm appearing in both Hotline Miami and Hotline Miami 2: Wrong Number. It can be found in the hands of enemies or in weapon spawns.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("dbpreview.png", 15f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("DB.png", 15f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("50 AE"); //load a copy of the 9mm cartridge
            customCartridge.name = "12 Gauge"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("DoubleBarrel.wav"),
                ModAPI.LoadSound("DoubleBarrel.wav"),
                ModAPI.LoadSound("DoubleBarrel.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Tony", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Tony, also known as The Tiger, is a playable protagonist in Hotline Miami 2: Wrong Number. He is a member of The Fans, and is the second playable Fan that is unlocked upon completion of the level Down Under after Corey.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("tonypreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Tony.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Revolver"), //item to derive from
        NameOverride = "Magnum", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Magnum is an unlockable firearm with a 6-round cylinder and a relatively slow fire rate. ", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("magnumprev.png", 26f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Magnum29.png", 26f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("38 Special"); //load a copy of the 9mm cartridge
            customCartridge.name = ".357 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Magnum.wav"),
                ModAPI.LoadSound("Magnum.wav"),
                ModAPI.LoadSound("Magnum.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
        NameOverride = "Mossberg", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Shotgun is a common firearm found in Hotline Miami and Hotline Miami 2: Wrong Number, at the hands of enemies or in weapon spawns. In Hotline Miami 2: Wrong Number, the Shotgun is the most common firearm in the game, as it is used by every standard enemy type except Soldiers.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("sgpreview.png", 19f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("shotgun.png", 19f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("50 AE"); //load a copy of the 9mm cartridge
            customCartridge.name = "12 Gauge"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Shotgun.wav"),
                ModAPI.LoadSound("Shotgun.wav"),
                ModAPI.LoadSound("Shotgun.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Biker's hair",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("BikerHair.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BikerHair.png", 11f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("alexhair.png");
            Instance.FixColliders();
        }  
    }
);

 ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "Silenced Uzi", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Silenced Uzi is a weapon used by Richter which is only available to Jacket by wearing the Richter Mask.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("uzipreview.png", 17f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mini uzi now fr.png", 17f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Silencer.wav"),
                ModAPI.LoadSound("Silencer.wav"),
                ModAPI.LoadSound("Silencer.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

 ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "FAMAE SAF", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The FAMAE is a sub-machine gun that is available in Hotline Miami 2: Wrong Number and is used by the Colombians and can be used by Manny Pardo and The Son.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("famaepreview.png", 19f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("FAMAE SAF.png", 19f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Famae.wav"),
                ModAPI.LoadSound("Famae.wav"),
                ModAPI.LoadSound("Famae.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pistol"), //item to derive from
        NameOverride = "9mm", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The 9mm is a common handgun in Hotline Miami 2: Wrong Number, it is commonly found in the hands of Gang Members and Policemen, it is also dual wielded by Soviet Dodgers, Ash Davis starts with a 9mm.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("9mmpreview.png", 30f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Beretta.png", 30f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("9mm.wav"),
                ModAPI.LoadSound("9mm.wav"),
                ModAPI.LoadSound("9mm.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Corey's hair",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("coreyhair.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("coreyhair.png", 11f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("coreyhair.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Corey", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Corey, also known as The Zebra, is a playable protagonist in Hotline Miami 2: Wrong Number and is the first playable member of the Fans. She is unlocked for the level in Down Under.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Coreypreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Corey.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Corey's mask",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("cmpreview.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("coreymask.png", 11f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("coreymask.png");
            Instance.FixColliders();
        }  
    }
);

 ModAPI.Register(
            new Modification()
            {
              OriginalItem = ModAPI.FindSpawnable("Sword"),
              NameOverride = "Katana",
              NameToOrderByOverride = "!",
              DescriptionOverride = "The Katana or Samurai Sword is a very fast attacking melee weapon that can be unlocked by gaining points.",
              CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
              ThumbnailOverride = ModAPI.LoadSprite("katanapreview.png", 10f),
              AfterSpawn = (Instance) =>
              {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("katana.png", 10f);
                Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
        NameOverride = "Kalashnikov", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Kalashnikov (Russian: Калашников) is a common firearm found at weapon spawns and in the hands of Mobsters and Soldiers.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("kalashnikovpreview.png", 13f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("kalashnikov.png", 13f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();
            Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.70f, 0.11f);

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm"); //load a copy of the 9mm cartridge
            customCartridge.name = "7.62x39mm"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("kalashnikov.wav"),
                ModAPI.LoadSound("kalashnikov.wav"),
                ModAPI.LoadSound("kalashnikov.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

 ModAPI.Register(
            new Modification()
            {
              OriginalItem = ModAPI.FindSpawnable("Knife"),
              NameOverride = "Drill",
              NameToOrderByOverride = "!",
              DescriptionOverride = "The Drill is a melee weapon in Hotline Miami and the Level Editor. It can only be legitimately obtained by wearing the Carl Mask.",
              CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
              ThumbnailOverride = ModAPI.LoadSprite("drillpreview.png", 23f),
              AfterSpawn = (Instance) =>
              {
                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("drill.png", 23f);
                Instance.FixColliders();

                                     AudioSource AS = Instance.AddComponent<AudioSource>();
                        AS.minDistance = 1;
                        AS.maxDistance = 10;




                        int index = 0;
                        AudioClip[] AudioData = new AudioClip[]
                        {
                            ModAPI.LoadSound("drill.wav"),
                        
                        };


                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            AS.clip = AudioData[index];
                            AS.Play();

                            index++;
                            if (index == AudioData.Length) index = 0;
                        };

        
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Carl", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Carl is a minor character in Hotline Miami, and the main character in the Carl comic by David C. Hopkins. He wore the Carl Mask.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("carlpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("carl.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Carl's mask",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("carlmaskpreview.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("carlmask.png", 12f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("carlmask.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pistol"), //item to derive from
        NameOverride = "Heavy Silenced Pistol", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The 9mm is a common handgun in Hotline Miami 2: Wrong Number, it is commonly found in the hands of Gang Members and Policemen, it is also dual wielded by Soviet Dodgers, Ash Davis starts with a 9mm.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("hsppreview.png", 30f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("heavysilencedpistol.png", 30f);
            Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.05f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Silencer.wav"),
                ModAPI.LoadSound("Silencer.wav"),
                ModAPI.LoadSound("Silencer.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

 ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "Skorpion", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Silenced Uzi is a weapon used by Richter which is only available to Jacket by wearing the Richter Mask.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("skorpionpreview.png", 24f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("skorpion.png", 24f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Scorpion.wav"),
                ModAPI.LoadSound("Scorpion.wav"),
                ModAPI.LoadSound("Scorpion.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "MP5", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Silenced Uzi is a weapon used by Richter which is only available to Jacket by wearing the Richter Mask.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("mp5kpreview.png", 21f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mp5k.png", 21f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Uzi.wav"),
                ModAPI.LoadSound("Uzi.wav"),
                ModAPI.LoadSound("Uzi.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Hammer"),
        NameOverride = "Hammer!",
        DescriptionOverride = "The Hammer is a weapon that appears in Hotline Miami and Hotline Miami 2: Wrong Number.",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("hammerpreview.png", 15f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hammer.png", 15f);
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),
        NameOverride = "Baseball Bat!",
        DescriptionOverride = "The Baseball Bat is a very common melee weapon seen in Hotline Miami and Hotline Miami 2: Wrong Number, where it is among one of the most common melee weapons in the entire series. It is most commonly found in the hands of Mobsters or Gangs.",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("bbpreview.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("baseballbat.png", 12f);
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Pool cue",
        DescriptionOverride = "The pool cue is an uncommon melee weapon found only near pool tables in various chapters.",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("pcpreview.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pool cue.png", 12f);
           
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"),
        NameOverride = "Broken pool cue",
        DescriptionOverride = " Broken cue is a weapon that can only be used to kill one regular enemy, and is a jagged stabbing weapon as opposed to a blunt weapon like the unbroken version.",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("bpcpreview.png", 15f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Broken cue.png", 15f);
            
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Hammer"),
        NameOverride = "Sledgehammer",
        DescriptionOverride = "The Sledgehammer is an unlockable melee weapon. It is one of the slower melee weapons in the game, making it rather redundant (aside from perverse pleasure) since all melee weapons are one-hit kills.",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("sledgepreview.png", 11f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sledge.png", 11f);
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Hammer"),
        NameOverride = "Crowbar",
        DescriptionOverride = "The Crowbar is a unique melee weapon found only on Chapter 5, Full House. This weapon is required to open up the manhole in the same chapter to earn the achievement and get the Jones Mask. It is the first weapon with a non-random spawn point.",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("crowbarpreview.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("crowbar.png", 12f);
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Mirror"),
        NameOverride = "Beer bottle",
        DescriptionOverride = "The bottle",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("sledgepreview.png", 20f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("beerbottle.png", 20f);
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"),
        NameOverride = "Broken beer bottle",
        DescriptionOverride = "oh nyo",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("bbottlepreview.png", 20f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("broken bottle.png", 20f);
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"),
        NameOverride = "Throwing knife",
        DescriptionOverride = "Name speaks for itself",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("tkpreview.png", 23f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("throwing knife.png", 23f);
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "Uzi", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = " The Uzi is a relatively uncommon firearm that is found in the hands of certain enemies and can appear as a Weapon Spawn after it is unlocked.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("minipreview.png", 17f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mini uzi not fr.png", 17f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Uzi.wav"),
                ModAPI.LoadSound("Uzi.wav"),
                ModAPI.LoadSound("Uzi.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Henchman", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The Henchman is a Russian mobster and a playable character in Hotline Miami 2: Wrong Number. He seems to have a personal friendship with the Son, the current boss of the Russian Mafia. He has reservations about The Son's newly started drug war with the Colombians, and wants out of the game.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Henchmanpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Henchman.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "Silenced Mac-10", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Bonus weapon!", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("miniuzipreview.png", 17f), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mini uzi.png", 17f);

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("9mm"); //load a copy of the 9mm cartridge
            customCartridge.name = ".380 ACP"; //set a name
            customCartridge.Damage *= 0.8f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.7f; //change the recoil
            customCartridge.ImpactForce *= 0.7f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("Silencer.wav"),
                ModAPI.LoadSound("Silencer.wav"),
                ModAPI.LoadSound("Silencer.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Jacket (Sprite version)", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Jacket, but more canon.", //new item description
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("canonjacketpreview.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("canonjacket.png");
            var flesh = ModAPI.LoadTexture("Flesh.png");
            var bone = ModAPI.LoadTexture("Bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 12f);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Jacket's Hair",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("Jackethair.png", 12f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Jackethair.png", 12f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
            armor.stabResistance = 356748f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;
            armor.otherSprite = ("coreyhair.png");
            Instance.FixColliders();
        }  
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"),
        NameOverride = "Butterfly Knife",
        DescriptionOverride = " The butterfly knife, also known as the balisong is a common melee weapon in Hotline Miami 2: Wrong Number, found in the hands of Gang Members, Colombians and Mobsters, all of which will drop the butterfly knife.",
        CategoryOverride = ModAPI.FindCategory("Hotline Playground"),
        ThumbnailOverride = ModAPI.LoadSprite("balisongpreview.png", 25f),
        AfterSpawn = (Instance) =>
        { 
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("balisong.png", 25f);
            
            Instance.FixColliders();
        }  
    }
);











        }
    }
}